<template>
  <v-row justify="center">
    <v-dialog v-model="dialog" fullscreen hide-overlay transition="dialog-bottom-transition">
      <v-card>
        <v-toolbar dark color="primary">
          <v-btn icon dark @click="$emit('setShow')">
            <v-icon>mdi-close</v-icon>
          </v-btn>

          <v-toolbar-title>Upload Videos</v-toolbar-title>
          <v-spacer></v-spacer>
          <v-toolbar-items>
            <v-btn dark text @click="save" :loading="salvando || carregando">
              Save
            </v-btn>
          </v-toolbar-items>
        </v-toolbar>

        <v-divider></v-divider>
        <v-container>
          <v-form @submit.prevent="save" ref="form" lazy-validation>
            <v-row>
              <v-col cols="6">
                <v-btn color="primary" @click="selectFile"><v-icon>mdi-plus</v-icon>Video</v-btn>
                <input
                  type="file"
                  id="files"
                  class="files"
                  multiple
                  accept="video/mp4"
                  @change="addVideos"/>
              </v-col>

              <v-col cols="6" class="text-right">
                  <v-btn dark @click="getVideos" :loading="salvando || carregando">
                    <v-icon>mdi-reload</v-icon>
                  </v-btn>
              </v-col>

              <v-col cols="12" class="text-center"><v-progress-circular v-if="carregando" indeterminate color="primary" ></v-progress-circular></v-col>
              <dialog-upload-item
                v-for="(dado, i) in dados"
                :key="i"
                :dado="dado"
                :index="i"
                :categories="categories"
                :playlists="playlists"
                :rules="rules"
                :path="(dado.path ? dado.path : '')"
                v-on:name="name => dado.name = name"
                v-on:category="category => dado.category = category"
                v-on:playlist="playlist => dado.playlist = playlist"
                v-on:progress="progress => dado.progress = progress"
                v-on:selectCover="selectCover"
                v-on:cover="cover"
                v-on:windowPlaylist="windowPlaylist"
                v-on:removeVideo="removeVideo"
                v-on:ruleCategory="rules.category"
                v-on:ruleName="rules.name"
                v-on:preview="setPreview"
                v-on:alterVideo="alterVideo"
                v-on:setVideo="setVideo"
              />
              <h2 v-if="!dados.length && !carregando && !salvando">Nenhum vídeo cadastrado até o momento</h2>
            </v-row>
          </v-form>

          <v-pagination
            v-model="pagination.current"
            :length="pagination.total"
            total-visible="12"
            @input="onPageChange"
        ></v-pagination>
        </v-container>

        <play-lists-form v-if="dialogPlayList" :show="dialogPlayList" v-on:windowPlaylist="windowPlaylist" v-on:getPlaylists="getPlaylists"/>
        <dialog-upload-preview v-if="previewVideo.path" :preview="previewVideo" v-on:setPreview="setPreview"/>
        <alert v-if="alert.showAlert" :show="alert.showAlert" :text="alert.msg" :type="alert.type" v-on:snackbar="alert.showAlert = false"/>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
export default {
  name: 'DialogUpload',
  data () {
    return {
      dados: [],
      videos: [],

      categories: [],
      playlists: [],
      dialog: false,

      rules: {
        name: [
          v => !!v || 'Preenchimento obrigatório'
        ],
        category: [
          v => !!v || 'Seleção obrigatória'
        ]
      },

      alert: {
        showAlert: false,
        msg: '',
        type: ''
      },
      carregando: false,
      salvando: false,

      pagination: {
        current: 1,
        total: 0
      },
      previewVideo: {
        path: '',
        img: ''
      },

      dialogPlayList: false
    }
  },
  props: {
    show: Boolean
  },
  created () {
    this.dialog = this.show
    this.getCategories()
    this.getVideos()
    this.getPlaylists()
  },
  methods: {
    alterVideo (id) {
      document.getElementById(id).click()
    },
    setPreview (preview = null) {
      this.previewVideo.path = (preview && preview.path ? preview.path : '')
      this.previewVideo.img = (preview && preview.cover ? preview.cover : '')
      this.$nuxt.$emit('pauseVideo')
    },
    async getVideos () {
      this.carregando = true
      this.dados = []
      await this.$axios.get(`profile/videos?page=${this.pagination.current}`).then((r) => {
        if (r.data) {
          this.dados = r.data.videos
          this.pagination.total = r.data.total
          this.pagination.current = r.data.current_page
        }
        this.carregando = false
      }).catch((e) => {
        this.carregando = false
      })
    },
    addVideos (e) {
      const videos = e.target.files || e.dataTransfer.files
      if (videos.length) {
        videos.forEach((v) => {
          this.videos[this.dados.length] = v
          this.dados.push({
            name: v.name.replace('.mp4', ''),
            category: null,
            playlist: null,
            cover: null,
            progress: 0
          })
        })
      }
    },
    setVideo (e) {
      const video = e.target.files[0] || e.dataTransfer.files[0]
      if (video) {
        this.$set(this.videos, e.target.dataset.id, video)
      }
    },
    save () {
      if (this.dados.length && this.$refs.form.validate()) {
        this.salvando = true
        if (this.dados.length) {
          this.dados.forEach((dado, i) => {
            const form = new FormData()
            form.append('name', dado.name)
            form.append('category', dado.category.value)
            form.append('playlist', (dado.playlist ? dado.playlist.value : ''))
            if (this.videos[i]) {
              form.append('video', this.videos[i])
            }
            const image = document.getElementById(`cover-${i}`).files[0]
            if (image) {
              form.append('cover', image)
            }

            if (dado.id) {
              console.log(this.videos)
              this.update(form, dado.id, i)
            } else {
              this.create(form, i)
            }
          })
        }
      } else {
        this.alertError('Alguns campos do formulário necessitam de atenção!', 'error')
      }
    },
    async create (form, i) {
      await this.$axios.post('videos', form, {
        onUploadProgress: (u) => {
          this.dados[i].progress = Math.round(u.loaded * 100 / u.total)
        }
      }).then((r) => {
        if (i + 1 === this.dados.length) {
          this.videos = []
          this.alertError(r.data.msg, 'success')
          this.salvando = false
          this.pagination.current = 1
          this.getVideos()
        }
      }).catch((e) => {
        this.salvando = false
        this.alertError('Erro ao cadastrar o vídeo!', 'error')
      })
    },
    async update (form, id, i) {
      await this.$axios.post(`videos/${id}`, form, {
        params: {
          _method: 'PUT'
        },
        onUploadProgress: (u) => {
          this.dados[i].progress = Math.round(u.loaded * 100 / u.total)
        }
      }).then((r) => {
        if (i + 1 === this.dados.length) {
          this.videos = []
          this.alertError(r.data.msg, 'success')
          this.salvando = false
          this.pagination.current = 1
          this.getVideos()
        }
      }).catch((e) => {
        this.salvando = false
        this.alertError('Erro ao atualizar o vídeo!', 'error')
      })
    },
    async getCategories () {
      await this.$axios.get('categories').then((r) => {
        if (r.data) {
          this.categories = r.data.map((c) => {
            return {
              value: c.id,
              text: c.name
            }
          })
        }
      }).catch((e) => {
      })
    },
    windowPlaylist () {
      this.dialogPlayList = !this.dialogPlayList
    },
    selectCover (i) {
      document.getElementById(`cover-${i}`).click()
    },
    cover (e) {
      const arquivo = e.target.files || e.dataTransfer.files
      if (!arquivo.length) {
        return
      }

      const name = this.dados[e.target.dataset.id]
      const reader = new FileReader()
      reader.onload = (e) => {
        name.cover = e.target.result
      }
      reader.readAsDataURL(arquivo[0])
    },
    selectFile () {
      document.getElementById('files').click()
    },
    async removeVideo (index) {
      const confirmation = confirm('Deseja realmente excluir este vídeo?')
      if (confirmation) {
        this.$nuxt.$emit('pauseVideo')
        const dado = this.dados[index]
        const video = this.videos[index]
        if (dado !== undefined) {
          this.dados.splice(index, 1)
        }

        if (video !== undefined) {
          this.videos.splice(index, 1)
        }

        if (dado.id) {
          await this.$axios.delete(`videos/${dado.id}`).then((r) => {
            if (r.data.status) {
              this.alertError('Vídeo excluído com sucesso!')
            }
          }).catch((e) => {
            this.alertError('Erro ao excluir o vídeo!', 'error')
          })
        }
      }
    },
    alertError (erro = null, type = 'success') {
      if (this.alert.showAlert) {
        this.alert.showAlert = false
      }
      this.alert.showAlert = true
      this.alert.msg = erro
      this.alert.type = type
    },
    getPlaylists () {
      this.playlists = []
      this.$axios.get('playlists/select').then((r) => {
        if (r.data) {
          this.playlists = r.data.map((p) => {
            return {
              value: p.id,
              text: p.name
            }
          })
        }
      }).catch((e) => {

      })
    },
    onPageChange () {
      this.getVideos()
    }
  }
}
</script>

<style>
  .files{
    display: none;
  }

  .preview{
    cursor: pointer;
  }
</style>
